IF(INSTALL_DLLS)
	# Variable holding needed dlls
	SET(${PROJECT_NAME}_QT_DLLS)
	# Qt dlls
	FIND_FILE(QT_CORE_DLL
		QtCore4.dll
		HINTS ${QT_BINARY_DIR}
		PATHS $ENV{PATH}
	)
	FIND_FILE(QT_GUI_DLL
		QtGui4.dll
		HINTS ${QT_BINARY_DIR}
		PATHS $ENV{PATH}
	)
	FIND_FILE(QT_OPENGL_DLL
		QtOpenGL4.dll
		HINTS ${QT_BINARY_DIR}
		PATHS $ENV{PATH}
	)
	FIND_FILE(QT_PHONON_DLL
		phonon4.dll
		HINTS ${QT_BINARY_DIR}
		PATHS $ENV{PATH}
	)
	INSTALL(FILES
		${QT_CORE_DLL}
		${QT_GUI_DLL}
		${QT_OPENGL_DLL}
		${QT_PHONON_DLL}
		DESTINATION    bin${BIN_SUFFIX}
		COMPONENT      dlls
	)
	LIST(APPEND ${PROJECT_NAME}_QT_DLLS
		${QT_CORE_DLL}
		${QT_GUI_DLL}
		${QT_OPENGL_DLL}
		${QT_PHONON_DLL}
	)
	MARK_AS_ADVANCED(
		QT_CORE_DLL
		QT_GUI_DLL
		QT_OPENGL_DLL
		QT_PHONON_DLL
	)

	# Debug Qt libraries
	FIND_FILE(QT_CORE_DLL_DEBUG
		QtCored4.dll
		HINTS ${QT_BINARY_DIR}
		PATHS $ENV{PATH}
	)
	FIND_FILE(QT_GUI_DLL_DEBUG
		QtGuid4.dll
		HINTS ${QT_BINARY_DIR}
		PATHS $ENV{PATH}
	)
	FIND_FILE(QT_OPENGL_DLL_DEBUG
		QtOpenGLd4.dll
		HINTS ${QT_BINARY_DIR}
		PATHS $ENV{PATH}
	)
	FIND_FILE(QT_PHONON_DLL_DEBUG
		phonond4.dll
		HINTS ${QT_BINARY_DIR}
		PATHS $ENV{PATH}
	)
	MARK_AS_ADVANCED(
		QT_CORE_DLL_DEBUG
		QT_GUI_DLL_DEBUG
		QT_OPENGL_DLL_DEBUG
		QT_PHONON_DLL_DEBUG
	)
	INSTALL(FILES
		${QT_CORE_DLL_DEBUG}
		${QT_GUI_DLL_DEBUG}
		${QT_OPENGL_DLL_DEBUG}
		${QT_PHONON_DLL_DEBUG}
		DESTINATION    bin${BIN_SUFFIX}
		CONFIGURATIONS Debug
		COMPONENT      dlls
		OPTIONAL
	)
	LIST(APPEND ${PROJECT_NAME}_QT_DLLS
		${QT_CORE_DLL_DEBUG}
		${QT_GUI_DLL_DEBUG}
		${QT_OPENGL_DLL_DEBUG}
		${QT_PHONON_DLL_DEBUG}
	)

	# Additional DLL install
	INSTALL(FILES
		${ADDITIONAL_DLL_DEPENDS}
		DESTINATION    bin${BIN_SUFFIX}
		COMPONENT      dlls
	)
	INSTALL(FILES
		${ADDITIONAL_DLL_DEPENDS_DEBUG}
		DESTINATION    bin${BIN_SUFFIX}
		COMPONENT      dlls
		CONFIGURATIONS Debug
	)
	INSTALL(FILES
		${ADDITIONAL_DLL_DEPENDS_RELEASE}
		DESTINATION    bin${BIN_SUFFIX}
		COMPONENT      dlls
		CONFIGURATIONS Release
	)
	MARK_AS_ADVANCED(
		ADDITIONAL_DLL_DEPENDS
		ADDITIONAL_DLL_DEPENDS_DEBUG
		ADDITIONAL_DLL_DEPENDS_RELEASE
	)
	SET(${PROJECT_NAME}_QT_DLLS ${${PROJECT_NAME}_QT_DLLS} CACHE STRING
		"Qt DLLs needed by ${PROJECT_NAME}" FORCE)

	ADD_CUSTOM_TARGET(${PROJECT_NAME}-dllsToBuildDir
		COMMENT "Copying needed DLLs to build directory"
	)
	SET_TARGET_PROPERTIES(${PROJECT_NAME}-dllsToBuildDir
		PROPERTIES FOLDER "HelperTargets")
	FOREACH(X ${${PROJECT_NAME}_QT_DLLS}
			${ADDITIONAL_DLL_DEPENDS}
			${ADDITIONAL_DLL_DEPENDS_DEBUG}
			${ADDITIONAL_DLL_DEPENDS_RELEASE})
		ADD_CUSTOM_COMMAND(TARGET POST_BUILD ${PROJECT_NAME}-dllsToBuildDir
			COMMAND "${CMAKE_COMMAND}" -E copy_if_different
				"${X}" "${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/$(Configuration)"
		)
	ENDFOREACH(X)
ENDIF(INSTALL_DLLS)
